require("Atlas.AtlasHelpers");
luanet.load_assembly("log4net");
luanet.load_assembly("System.Windows.Forms");
local Application = luanet.import_type("System.Windows.Forms.Application");

local Settings = {};
Settings.AutoSearch = GetSetting("AutoSearch");
Settings.SearchUrl = GetSetting("SearchUrl");
Settings.SearchTable = "";
Settings.IsbnSearchField = "";
Settings.TitleSearchField = "";

local interfaceMngr = nil;
local OpenLibrarySearchForm = {};
OpenLibrarySearchForm.Form = nil;
OpenLibrarySearchForm.Browser = nil;
OpenLibrarySearchForm.RibbonPage = nil;

function Init()
    if (Application.ProductName == "ILLiad" and (GetFieldValue("Transaction","ProcessType") == "Lending" or GetFieldValue("Transaction","RequestType")=="Article")) or
       (Application.ProductName == "Ares" and (GetFieldValue("Item","ItemType") == "SER" )) then
        LogDebug("Addon not applicable to this process type or item type. Cancelling initialization.");
        return;
    end

    if Application.ProductName == "ILLiad" then
        Settings.SearchTable = "Transaction";
        Settings.IsbnSearchField = "ISSN";
        Settings.TitleSearchField = "LoanTitle";
    elseif Application.ProductName == "Ares" then
        Settings.SearchTable = "Item";
        Settings.IsbnSearchField = "ISXN";
        Settings.TitleSearchField = "Title";
    else
        LogError("Initialization error: Unknown Application.");
        return;
    end

	interfaceMngr = GetInterfaceManager();
	OpenLibrarySearchForm.Form = interfaceMngr:CreateForm("OpenLibrary", "Script");
	OpenLibrarySearchForm.Browser = OpenLibrarySearchForm.Form:CreateBrowser("OpenLibrary Search", "OpenLibrary Search", "OpenLibrary Search", "Chromium");
	OpenLibrarySearchForm.Browser.TextVisible = false;
	OpenLibrarySearchForm.RibbonPage = OpenLibrarySearchForm.Form:GetRibbonPage("OpenLibrary Search");
	OpenLibrarySearchForm.RibbonPage:CreateButton("Search", GetClientImage("Search32"), "Search", "OpenLibrary");
	OpenLibrarySearchForm.Form:Show();
	if Settings.AutoSearch then
		Search();
    else
        OpenLibrarySearchForm.Browser:Navigate(Settings.SearchUrl);
    end

end

function Search()
    local searchText = "";
    local isbn = GetFieldValue(Settings.SearchTable, Settings.IsbnSearchField);
    if (isbn ~= nil and isbn ~= "") then
        LogDebug("Searching by ISBN");
        searchText = isbn;
    else
        LogDebug("Searching by Title");
        searchText = GetFieldValue(Settings.SearchTable, Settings.TitleSearchField);
    end
    if (searchText ~= nil and searchText ~= "") then
        OpenLibrarySearchForm.Browser:Navigate(Settings.SearchUrl .. "/search/?q=" .. AtlasHelpers.UrlEncode(searchText));
    else
        LogDebug("No title or ISBN. Cancelling search.")
        OpenLibrarySearchForm.Browser:Navigate(Settings.SearchUrl);
    end
end


